︠e8c61893-850f-4d3d-b7ac-9524c7297b18i︠
%md

# Welcome to the Sage Lab!

Today we'll show you some cool math things you can do using a computer,
and teach you how to solve math problems using programming!

︡64afa4e8-9edd-40dd-a4ae-0199a79fdf93︡︡{"done":true,"md":"\n# Welcome to the Sage Lab!\n\nToday we'll show you some cool math things you can do using a computer,\nand teach you how to solve math problems using programming!"}
︠fb668e4f-d95e-447e-a412-43c99e9656eci︠
%md

# Part 1: Sage: The Final Frontier

We can use computers to do arithmetic.
The cell below contains a basic sum.
Click on the $2+2$ and hit shift-enter to evaluate that sum
(in general we will be executing snippets of code in this worksheet;
to do so just click on the cell and hit shift-enter,
or hit the green Run button at the top left of the page).

### Example

Use shift-enter to evaluate the following cell.

︡14dd52dc-c7cb-4dc0-985e-16125735f060︡︡{"done":true,"md":"\n# Part 1: Sage: The Final Frontier\n\nWe can use computers to do arithmetic.\nThe cell below contains a basic sum.\nClick on the $2+2$ and hit shift-enter to evaluate that sum\n(in general we will be executing snippets of code in this worksheet;\nto do so just click on the cell and hit shift-enter,\nor hit the green Run button at the top left of the page).\n\n### Example\n\nUse shift-enter to evaluate the following cell."}
︠fcbae1c2-e8c6-4b38-8511-f0a5b22a8fc7s︠

2+2

︡fac5b00f-b4f6-4ada-bd20-c8c986a23f9a︡{"stdout":"4\n"}︡{"done":true}︡
︠75aab917-b0bf-45bc-b3b2-f26a7aa4ff68i︠
%md

## FUN-ctions

We can define a variable $x$ and a function $f$ which operates on the input $x$.
In the code below we tell the computer that $x$ is a variable,
and $f$ is the function $f(x) = (x+2)(x^3-4)$. We then calculate $f(3)$.

### Example 1

Use shift-enter to evaluate the following cell.

︡26e84d4a-acad-4f74-af5f-28549b422419︡︡{"done":true,"md":"\n## FUN-ctions\n\nWe can define a variable $x$ and a function $f$ which operates on the input $x$.\nIn the code below we tell the computer that $x$ is a variable,\nand $f$ is the function $f(x) = (x+2)(x^3-4)$. We then calculate $f(3)$.\n\n### Example 1\n\nUse shift-enter to evaluate the following cell."}
︠3dc7e75d-e3ae-4051-9304-bb805d7e5f94s︠

x = var('x')
f = (x + 2)*(x^3 - 4)
f(x = 3)

︡eefa1920-eedb-455e-b7b3-adb9273e55e5︡{"stdout":"115\n"}︡{"done":true}︡
︠378f700d-5d06-4384-a1d5-9741605b1453i︠
%md

### Example 2

Alternatively we can define our function exactly the way
we would write it out by hand.

︡93a28cb1-c376-4a5e-bd84-ec171491d7e5︡︡{"done":true,"md":"\n### Example 2\n\nAlternatively we can define our function exactly the way\nwe would write it out by hand."}
︠316503ce-676c-4191-a391-348c09556fads︠

f(x) = (x + 2)*(x^3 - 4)
f(3)

︡dd7f0b0c-5222-49cf-9e99-8b3875799451︡{"stdout":"115\n"}︡{"done":true}︡
︠c401ca10-e3fa-431f-a213-ec219d2f4e8fi︠
%md

## Cool Pictures

With Sage we can also plot functions with 2D and 3D graphs.

### Example

Plot the function we defined above by evaluating the
following cell.

︡d409560a-4fc7-4a21-afbc-798092c9fcc4︡︡{"done":true,"md":"\n## Cool Pictures\n\nWith Sage we can also plot functions with 2D and 3D graphs.\n\n### Example\n\nPlot the function we defined above by evaluating the\nfollowing cell."}
︠e375bb4c-807e-4325-8b2f-dcf4237b0c42s︠

plot(f, xmin=-3, xmax=3)

︡bb64938f-e557-46b3-a5ce-54c30be26600︡{"stderr":"/ext/sage/sage-8.1/local/lib/python2.7/site-packages/matplotlib/font_manager.py:273: UserWarning: Matplotlib is building the font cache using fc-list. This may take a moment.\n  warnings.warn('Matplotlib is building the font cache using fc-list. This may take a moment.')\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-39981aeb-00ae-4853-9eb3-d5c73508ede1/853/tmp_MmMVzg.svg","show":true,"text":null,"uuid":"0810605b-1cbd-4958-ad27-847b1123788c"},"once":false}︡{"done":true}︡︡{"done":true}
︠47fb9e3b-51fe-4207-b1bd-1719cdacf966i︠
%md

## Calculus 1

For those of you who know a bit of calculus,
we can compute the *derivative* of $f(x)$.

### Example

Find the derivative of the function $f$ we defined above
by evaluating the following cell.

︡2a2da2b3-2fcd-4320-98c5-3e7014ecab3b︡︡{"done":true,"md":"\n## Calculus 1\n\nFor those of you who know a bit of calculus,\nwe can compute the *derivative* of $f(x)$.\n\n### Example\n\nFind the derivative of the function $f$ we defined above\nby evaluating the following cell."}
︠4e3cdf80-13e1-4548-80c0-ad0137fa58b2s︠

f.derivative()

︡88f02dfe-b64b-4ac7-8939-3f4c03edc139︡{"stdout":"x |--> 3*(x + 2)*x^2 + x^3 - 4\n"}︡{"done":true}︡
︠de29a00d-0e11-4966-93bf-11734acbe76ai︠
%md

## Calculus 2

For those with a bit more calculus, we can
use Sage to both approximate and calculate (when possible)
*integrals*.

### Example

Evaluate the following cell to find an interactive
Riemann sums application.

︡d1cb489c-4b95-4ac3-8dee-da5494095ebf︡︡{"done":true,"md":"\n## Calculus 2\n\nFor those with a bit more calculus, we can\nuse Sage to both approximate and calculate (when possible)\n*integrals*.\n\n### Example\n\nEvaluate the following cell to find an interactive\nRiemann sums application."}
︠132c7961-158b-4cf2-9ffc-027634a10c51s︠

@interact(auto_update=True)
def _(
        func = input_box(cos(x)*x + 3,label='Function',width=50),
        rectangle_type = selector(['Midpoint', 'Left', 'Right', 'Upper', 'Lower'], nrows=1, label="Endpoint rule"),
        N=slider([1..100],label='Number of rectangles',default=3),
        interval=range_slider([-50..50],default=(-10,10),label="Interval"),
        line_color=color_selector(widget='colorpicker', label="Line color"),
        bar_color=color_selector(widget='colorpicker', label="Rectangle color",default='#00b334'),
        dot_color=color_selector(widget='colorpicker',label='Dot color',default='#000000')
    ):
    import time
    start = time.time()
    a = interval[0]
    b = interval[1]
    dx = (b - a)/N
    area = 0
    f = fast_callable(func,vars=['x'])
    def height(a,b,f):
        if rectangle_type == 'Left':
            c = a
        elif rectangle_type == 'Midpoint':
            c = (b+a)/2
        elif rectangle_type == 'Right':
            c = b
        elif rectangle_type == 'Upper': #could be much better
            Y = [f(a + (b-a)*i/100.0) for i in range(101)]
            c = a + (b-a)*Y.index(max(Y))/100.0
        elif rectangle_type == 'Lower':
            Y = [f(a + (b-a)*i/100.0) for i in range(101)]
            c = a + (b-a)*Y.index(min(Y))/100.0
        return c,f(c)
    rects = Graphics()
    pts = Graphics()
    for i in range(N):
        xi = dx*i + a
        mx,my = height(xi,xi+dx,f)
        rects += polygon([(xi,0),(xi+dx,0),(xi+dx,my),(xi,my)],color=bar_color,alpha=0.6)
        rects += line([[xi,0],[xi,my]],thickness=1,color='#000000',alpha=1) #left side
        rects += line([[xi+dx,0],[xi+dx,my]],thickness=1,color='#000000',alpha=1) #right side
        rects += line([[xi,my],[xi+dx,my]],thickness=1,color='#000000',alpha=1) #top
        pts += point([mx,my],color=dot_color,size=50,alpha=1)
        area += dx * my
    p = plot(f,(x,a,b),color=line_color,thickness=2)
    end = time.time()
    print('Time taken: %s' % (end-start))
    show(p + rects + pts)
    print("\n")
    show("$\\text{Estimated area} \\approx %s$" % area.n(100))
    try:
        show("$\\text{Calculated integral} = %s $" % integrate(func,x,a,b))
        show("$\qquad\qquad\qquad\qquad \\approx %s$" % integrate(func,x,a,b).n(100))
    except Exception as e:
        print("Unable to integrate")

︡04f84cd2-4886-478a-9d97-132369f7e77f︡{"interact":{"controls":[{"control_type":"input-box","default":"x*cos(x) + 3","label":"Function","nrows":1,"readonly":false,"submit_button":null,"type":null,"var":"func","width":50},{"button_classes":null,"buttons":false,"control_type":"selector","default":0,"label":"Endpoint rule","lbls":["Midpoint","Left","Right","Upper","Lower"],"ncols":null,"nrows":1,"var":"rectangle_type","width":null},{"animate":true,"control_type":"slider","default":2,"display_value":true,"label":"Number of rectangles","vals":["1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50","51","52","53","54","55","56","57","58","59","60","61","62","63","64","65","66","67","68","69","70","71","72","73","74","75","76","77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100"],"var":"N","width":null},{"animate":true,"control_type":"range-slider","default":[40,60],"display_value":true,"label":"Interval","vals":["-50","-49","-48","-47","-46","-45","-44","-43","-42","-41","-40","-39","-38","-37","-36","-35","-34","-33","-32","-31","-30","-29","-28","-27","-26","-25","-24","-23","-22","-21","-20","-19","-18","-17","-16","-15","-14","-13","-12","-11","-10","-9","-8","-7","-6","-5","-4","-3","-2","-1","0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31","32","33","34","35","36","37","38","39","40","41","42","43","44","45","46","47","48","49","50"],"var":"interval","width":null},{"Color":"<class 'sage.plot.colors.Color'>","control_type":"color-selector","default":"#0000ff","hide_box":false,"label":"Line color","readonly":false,"var":"line_color","widget":"colorpicker"},{"Color":"<class 'sage.plot.colors.Color'>","control_type":"color-selector","default":"#00b334","hide_box":false,"label":"Rectangle color","readonly":false,"var":"bar_color","widget":"colorpicker"},{"Color":"<class 'sage.plot.colors.Color'>","control_type":"color-selector","default":"#000000","hide_box":false,"label":"Dot color","readonly":false,"var":"dot_color","widget":"colorpicker"}],"flicker":false,"id":"e16f9278-a0f0-4b47-80aa-5796a71d9932","layout":[[["func",12,null]],[["rectangle_type",12,null]],[["N",12,null]],[["interval",12,null]],[["line_color",12,null]],[["bar_color",12,null]],[["dot_color",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠cb4167a5-267f-496f-ace2-8bb214980c89i︠
%md

## Even cooler pictures

Why restrict ourselves to 2-dimensional plots?

### Example 1

Here's a 3d graph of the function $z = y\sin(x-y)\cos(x)$:

︡7ed6f20b-49b7-4385-89d9-c2e597e29344︡︡{"done":true,"md":"\n## Even cooler pictures\n\nWhy restrict ourselves to 2-dimensional plots?\n\n### Example 1\n\nHere's a 3d graph of the function $z = y\\sin(x-y)\\cos(x)$:"}
︠a0715696-4159-4268-b414-253fc43536c1︠

x,y = var('x,y')
plot3d(sin(x - y)*y*cos(x), (x,-3,3), (y,-3,3), mesh=True)

︡dfc46bd8-2eba-4227-945f-42c588c30575︡
︠094ada11-09e5-434d-9607-8f0520cf96cdi︠
%md

### Example 2

Here's a plot of the famous Riemann zeta function
$\zeta(s) = \sum_{i=1}^\infty \frac{1}{n^s}$
that uses complex numbers (ask your presenters about this one)!

︡5b72ff4e-335c-49aa-b7f6-23716cbd1cd8︡︡{"done":true,"md":"\n### Example 2\n\nHere's a plot of the famous Riemann zeta function\n$\\zeta(s) = \\sum_{i=1}^\\infty \\frac{1}{n^s}$\nthat uses complex numbers (ask your presenters about this one)!"}
︠0d4d942e-8b4b-4159-98aa-2a8663007d0b︠

complex_plot(zeta, (-20,10), (-30,30))

︡ddab8582-85b3-40ff-b46f-ba9d55605732︡
︠52dbfd21-f16b-4f5c-bb7e-b235a87aebcfi︠
%md

### Example 3

Ever heard of the Mandelbrot Set? It is an example of
some really cool mathematical objects called *fractals*.

Try move some of the sliders and see what happens...

︡9e3f0958-8403-42bc-b897-3f86413b8a39︡︡{"done":true,"md":"\n### Example 3\n\nEver heard of the Mandelbrot Set? It is an example of\nsome really cool mathematical objects called *fractals*.\n\nTry move some of the sliders and see what happens..."}
︠1fde772b-ade4-4a1d-820f-b50509215af8︠

@interact
def mandel_plot(expo = slider(-10,10,0.1,2),
        formula = ['mandel','ff'],
        iterations=slider(1,100,1,30),
        zoom_x = range_slider(-2,2,0.01,(-2,1)),
        zoom_y = range_slider(-2,2,0.01,(-1.5,1.5))):
    var('z c')
    f(z,c) = z^expo + c
    ff_m = fast_callable(f, vars=[z,c], domain=CDF)

    # messing around with fast_callable
    for i in range(int(iterations)/3):
        f(z,c) = f(z,c)^expo+c
    ff = fast_callable(f, vars=[z,c], domain=CDF)

    def mandel(z):
        c = z
        for i in range(iterations):
            z = ff_m(z,c)
            if abs(z) > 2:
                return z
        return z
    print 'z <- z^%s + c' % expo

    # calling ff three times, otherwise it fast_callable exceeds a recursion limit
    if formula is 'ff':
         func = lambda z: ff(ff(ff(z,z),z),z)
    elif formula is 'mandel':
         func = mandel

    complex_plot(func, zoom_x,zoom_y, plot_points=200, dpi=150).show(frame=True, aspect_ratio=1)

︡15e635c7-35bf-4c3e-85b3-0b5970ddecb4︡
︠24c734a0-49aa-476a-ad38-d2b9c093c8d3i︠
%md

## Codes and Secrets, i.e., the cool stuff

Let's do some cryptography. Enter a message in the text box below,
then use the slider to encrypt it! This is an example of a
*Caesar cipher*, where we take a message and shift all the letters
to the left or right by a fixed amount
(for example a shift by 1 would send $a$ to $b$, $b$ to $c$ etc.).

### Example

Can you create a secret message and pass it to the person next to you to decode?

Try to intercept someone elses message and decoding it.

︡f74c0d27-0a89-46ad-ab31-abb425eb366d︡︡{"done":true,"md":"\n## Codes and Secrets, i.e., the cool stuff\n\nLet's do some cryptography. Enter a message in the text box below,\nthen use the slider to encrypt it! This is an example of a\n*Caesar cipher*, where we take a message and shift all the letters\nto the left or right by a fixed amount\n(for example a shift by 1 would send $a$ to $b$, $b$ to $c$ etc.).\n\n### Example\n\nCan you create a secret message and pass it to the person next to you to decode?\n\nTry to intercept someone elses message and decoding it."}
︠43b12f27-fb66-4593-a65c-27f69d0ba0e4︠

@interact
def _(
        message=input_box(default='sage is cool',type=str,label='Message'),
        key=slider([0..25],0,label='Shift by:',width=35),
        method=selector(["Encrypt","Decrypt"],label="Method",buttons=True)
    ):
    S = ShiftCryptosystem(AlphabeticStrings())
    k = key
    m = S.encoding(message)
    print "Message   = %s" % m
    print "Key       = %s" % k
    if method is "Encrypt":
        print "Encrypted = %s" % S.enciphering(k,m)
    if method is "Decrypt":
        print "Decrypted = %s" % S.deciphering(k,m)

︡2c746549-174b-4a60-b80a-d2165cef2cd5︡
︠75134258-e010-4c56-be23-849806342aef︠

︡f4c60df1-7210-4fd7-914b-50da26838578︡
︠08c3610b-b874-4927-9dc1-06ebabd6272e︠
############################KEEP####################################################
︡48bf7c8f-b904-4e0f-ac5d-45fd2d7d2e75︡
︠c55a2cae-dd8b-4cc0-b788-61eed545f16e︠
##############################GOING#################################################
︡2c2355ad-9b29-400d-bc12-4851465a86c7︡
︠1bc8b523-eaa1-4f3c-8898-5067d1bdaf51︠
###############################YOU'RE###############################################
︡15da2d93-9da6-4d5b-9126-15a04a243f97︡
︠8491c880-d6de-4a72-8bbc-c42454ea2bf5︠
##################################DOING#############################################
︡6bc389c1-8d6f-49d8-ad21-c207776fb15d︡
︠e1982823-4afa-4905-9f8d-f9662d5f0dea︠
####################################GREAT###########################################
︡44ae32ed-39bb-434b-8159-ee098300a9f2︡
︠28aeeb0b-4ae0-48aa-bcad-9d308901c765︠

︡ba826b34-1d84-40b5-9156-090fcc081d46︡
︠88175a93-6dc4-428b-8612-5b4d236383d3i︠
%md

# Part 2: Mathematical Programming

There are thousands of ways we can use computers to help us do math.
We're going to take a closer look at how to program a computer
to effortlessly do tedious calculations that would take a human ages to do.
This will allow us to explore a beautiful unsolved problem
in mathematics relating to prime numbers.

︡61d9bc35-7840-4947-920f-4af08fa47c35︡︡{"done":true,"md":"\n# Part 2: Mathematical Programming\n\nThere are thousands of ways we can use computers to help us do math.\nWe're going to take a closer look at how to program a computer\nto effortlessly do tedious calculations that would take a human ages to do.\nThis will allow us to explore a beautiful unsolved problem\nin mathematics relating to prime numbers."}
︠12bdfaaf-aec7-4618-ae0f-bc7293325fbci︠
%md

## A Modest Goal

What is the sum of the first $100$ whole numbers?
That is, can you calculate $1 + 2 + 3 + 4 + ... + 99 + 100$?

### Example

In the cell below we've typed out a simple command in sage: $1 + 2 + 3$.
To evaluate this expression, click on the text and hit shift-enter.

︡fe9b58c7-14e7-4e3a-81fa-2f9e5e698847︡︡{"done":true,"md":"\n## A Modest Goal\n\nWhat is the sum of the first $100$ whole numbers?\nThat is, can you calculate $1 + 2 + 3 + 4 + ... + 99 + 100$?\n\n### Example\n\nIn the cell below we've typed out a simple command in sage: $1 + 2 + 3$.\nTo evaluate this expression, click on the text and hit shift-enter."}
︠939e6c0f-ba87-484c-ba35-4dd2fc6fcf2e︠

1 + 2 + 3

︡668cea56-2989-4d36-910b-ff0466084dbd︡
︠7a35486c-3496-42bb-8e29-3add856458b3i︠
%md

### Challenge

Can you modify the above code to compute the sum of the first
$10$ whole numbers, i.e. $1 + 2 + 3 + 4 + 5 + 6 + 7 + 8 + 9 + 10$?

Feel free to use copy and paste if you want.

︡e6b24e20-7812-4d57-8a1d-3de7d2a8e6ea︡︡{"done":true,"md":"\n### Challenge\n\nCan you modify the above code to compute the sum of the first\n$10$ whole numbers, i.e. $1 + 2 + 3 + 4 + 5 + 6 + 7 + 8 + 9 + 10$?\n\nFeel free to use copy and paste if you want."}
︠20b7a170-7978-404f-b0be-3df3328d9110︠

# put code here

︡494530bf-7778-4c29-936a-73cad4833294︡
︠678d784b-9e03-41f2-847f-2d643784ffe7i︠
%md

## A LOOPy solution

We could also modify the above code to sum the first $100$ whole numbers,
but this would be pretty boring and tedious.
Luckily, we have a much better solution, the __for loop__.
It allows us to specify an instruction that repeats in a systematic way.
Intelligent loops are one of the most fundamental programming ideas.

The code below defines a number $x$, which we initially set to be zero.
Note that here "$=$" means "set the variable on the left to be the value
on the right".
Then starting at $n=1$ we add $n$ to our number $x$.
Then we increment $n$ to be equal to $2$, and add it to $x$ again,
then we increment $n$ to $3$ and add it to $x$ again etc.
We keep doing this all the way up to $n=10$.
In so doing we've added the numbers $1, 2, 3, 4, 5, 6, 7, 8, 9$ and $10$ to $0$.
Finally we print out the number $x$.

Hit shift-enter after clicking on the code below,
and you should find that the number printed out should
equal the number you calculated above.

︡13ff95e2-0eb8-4193-b4e7-d37335ebd3e8︡︡{"done":true,"md":"\n## A LOOPy solution\n\nWe could also modify the above code to sum the first $100$ whole numbers,\nbut this would be pretty boring and tedious.\nLuckily, we have a much better solution, the __for loop__.\nIt allows us to specify an instruction that repeats in a systematic way.\nIntelligent loops are one of the most fundamental programming ideas.\n\nThe code below defines a number $x$, which we initially set to be zero.\nNote that here \"$=$\" means \"set the variable on the left to be the value\non the right\".\nThen starting at $n=1$ we add $n$ to our number $x$.\nThen we increment $n$ to be equal to $2$, and add it to $x$ again,\nthen we increment $n$ to $3$ and add it to $x$ again etc.\nWe keep doing this all the way up to $n=10$.\nIn so doing we've added the numbers $1, 2, 3, 4, 5, 6, 7, 8, 9$ and $10$ to $0$.\nFinally we print out the number $x$.\n\nHit shift-enter after clicking on the code below,\nand you should find that the number printed out should\nequal the number you calculated above."}
︠4caeb848-c5e5-4ea5-a8ff-4608322fc2aeo︠

#Adds the numbers 1, 2, 3, ..., 10 together
x = 0
for n in range(1, 11):
    x = x+n
print(x)

︡b6e04480-a109-4feb-bc73-06928dd17e63︡
︠f56c598b-c764-4f62-9433-511d3e881e18i︠
%md

### Challenge

Copy and paste the code in the following cell into the blank one below.
Can you modify it to calculate the sum of the first 100 whole numbers?
How about the first 10000 whole numbers?

︡de7e5e20-1fc3-4b19-98d8-463266d3f00c︡︡{"done":true,"md":"\n### Challenge\n\nCopy and paste the code in the following cell into the blank one below.\nCan you modify it to calculate the sum of the first 100 whole numbers?\nHow about the first 10000 whole numbers?"}
︠e80f484f-dff6-4c4a-b327-4c0540384633︠

#insert code here
x = 0
for n in range(1, 101):
    x = x+n
print(x)

︡0a4a39e6-a1fc-433e-9751-be7c3324aeae︡
︠49df57ff-756a-4ea3-beb7-e3143914d6aci︠
%md

## All in all

See how easy that was? Much faster than doing it in your head
or typing out the full instruction manually!

For loops are cool.

︡0b912e99-754e-4c8e-af68-4507ed1d6337︡︡{"done":true,"md":"\n## All in all\n\nSee how easy that was? Much faster than doing it in your head\nor typing out the full instruction manually!\n\nFor loops are cool."}
︠e7a2904f-2491-449b-975a-7c4497a41286i︠
%md

## Level 2

Above we found out how to add all the numbers
$1, 2, 3, \dots, 100$. What if we only want to add the
even numbers, i.e., $2, 4, 6, 8, \dots, 96, 98, 100$?

### Don't Reinvent the Wheel

We can just modify our code to do exactly this.
Take a look at the code below.

︡13e2ba7c-f43f-40a2-acb1-ee481c2c2810︡︡{"done":true,"md":"\n## Level 2\n\nAbove we found out how to add all the numbers\n$1, 2, 3, \\dots, 100$. What if we only want to add the\neven numbers, i.e., $2, 4, 6, 8, \\dots, 96, 98, 100$?\n\n### Don't Reinvent the Wheel\n\nWe can just modify our code to do exactly this.\nTake a look at the code below."}
︠4b99d411-e4d3-46ce-b64c-739122ff8e4co︠

#Adds the numbers 2, 4, 6, ..., 98, 100 together
x = 0
for n in range(1,101):
    if 2.divides(n):
        x = x+n
print(x)

︡3b988302-e596-4388-a5d9-1bd2b8f035ee︡
︠2077c265-a41e-42af-a076-5126255a4381i︠
%md

## Explanation

What we've done above is to first test if the number $n$ is even or odd
by checking if it's divisible by 2. If it is, then we add it to our number $x$.
To do this we've used something called a __if statement__.
This tests a specified condition and only executes the following
line or lines of code if that statement is true.

For us, we only add $n$ to $x$ if 2 divides $n$.

︡f5c7e953-c194-41c7-acb8-ca0d68bc9396︡︡{"done":true,"md":"\n## Explanation\n\nWhat we've done above is to first test if the number $n$ is even or odd\nby checking if it's divisible by 2. If it is, then we add it to our number $x$.\nTo do this we've used something called a __if statement__.\nThis tests a specified condition and only executes the following\nline or lines of code if that statement is true.\n\nFor us, we only add $n$ to $x$ if 2 divides $n$."}
︠e3187f6a-5217-46d2-8148-b4049ed1374fi︠
%md

## FUN-ctions again, but in computers

Now we're going to use a for loop to do something even more awesome.
Remember the definition of a prime number:

>A positive whole number $p$ is prime if the only positive whole numbers
>that divide $p$ are 1 and $p$ itself.

For example $2, 3, 5, 7$ and $11$ are all prime, but $6$ and
$12$ are not (as both $6$ and $12$ are divisible by $2$ and $3$).

Sometimes we want to repeat the same snippet of code over and over again,
in this case we made a __function__.
Just above, we used the function `divides`.
We are going to define a function that uses a for loop to test if a
given integer is prime or not. Below is some code that creates a function
`is_it_prime`, that takes as input a positive whole number $p$ and
returns the value `True` if $p$ is a prime number, or `False` if it isn't.

︡c04b2aad-83ed-4ee2-9c2a-d80d131941f6︡︡{"done":true,"md":"\n## FUN-ctions again, but in computers\n\nNow we're going to use a for loop to do something even more awesome.\nRemember the definition of a prime number:\n\n>A positive whole number $p$ is prime if the only positive whole numbers\n>that divide $p$ are 1 and $p$ itself.\n\nFor example $2, 3, 5, 7$ and $11$ are all prime, but $6$ and\n$12$ are not (as both $6$ and $12$ are divisible by $2$ and $3$).\n\nSometimes we want to repeat the same snippet of code over and over again,\nin this case we made a __function__.\nJust above, we used the function `divides`.\nWe are going to define a function that uses a for loop to test if a\ngiven integer is prime or not. Below is some code that creates a function\n`is_it_prime`, that takes as input a positive whole number $p$ and\nreturns the value `True` if $p$ is a prime number, or `False` if it isn't."}
︠a7ad3f0d-b8f7-4d5b-bed6-8bb68ccad23d︠

def is_it_prime(p):
    primality = True
    if 2.divides(p):
        primality = False
    return primality

︡4565d62a-008f-4f9c-a16b-31d67c47d7dc︡
︠8603eacc-12e8-46e2-9ab5-3b5e75f7b18bi︠
%md

## Try it out

Click on the code above and hit shift-enter. This evaluates the code;
the computer then learns the function `is_it_prime`, so we can then use it.
In the empty cell below type `is_it_prime(2)` and hit shift-enter
to see if the code works. Does it work for $n=3$? How about $n=4, 5, 6, 7, 8$ and $9$?

︡8cf47d5a-527b-435a-994f-d022ebf3485e︡︡{"done":true,"md":"\n## Try it out\n\nClick on the code above and hit shift-enter. This evaluates the code;\nthe computer then learns the function `is_it_prime`, so we can then use it.\nIn the empty cell below type `is_it_prime(2)` and hit shift-enter\nto see if the code works. Does it work for $n=3$? How about $n=4, 5, 6, 7, 8$ and $9$?"}
︠f47c409f-6f9e-4515-ab37-e16d79bd94ea︠

#insert code here

︡cf68e74f-c81b-4293-aec6-244d42613fd5︡
︠ae47d451-dd4a-49b3-848b-ffb9e16e3145i︠
%md

## Bugs in the code

Oh no, our function doesn't work properly!

You should have found that it returns `True` for $n=9$.
But $9$ isn't prime - it's divisible by $3$!
It also returns `False` for $n=2$ - but $2$ is a prime number.

Take a closer look at the function. For input number $p$
we are only testing if $2$ divides $p$.
If it does then we return `False`; otherwise return `True`.
However there are plenty of odd numbers that aren't prime - for
example 9, 15, 21 and 45. And there is one even number
that *is* prime - namely the number $2$.

In order to correctly ascertain if a number $p$ is prime
we need to check if *any* numbers less than $p$ divide into
$p$.

### Challenge

Can you see why we don't need to check any numbers larger than $p$?

︡3c6d2605-5cf2-4347-9a33-647fecb50a28︡︡{"done":true,"md":"\n## Bugs in the code\n\nOh no, our function doesn't work properly!\n\nYou should have found that it returns `True` for $n=9$.\nBut $9$ isn't prime - it's divisible by $3$!\nIt also returns `False` for $n=2$ - but $2$ is a prime number.\n\nTake a closer look at the function. For input number $p$\nwe are only testing if $2$ divides $p$.\nIf it does then we return `False`; otherwise return `True`.\nHowever there are plenty of odd numbers that aren't prime - for\nexample 9, 15, 21 and 45. And there is one even number\nthat *is* prime - namely the number $2$.\n\nIn order to correctly ascertain if a number $p$ is prime\nwe need to check if *any* numbers less than $p$ divide into\n$p$.\n\n### Challenge\n\nCan you see why we don't need to check any numbers larger than $p$?"}
︠44a37c94-9773-42e4-bb6c-967a35335ef3︠

# code here

︡b427e0bf-77f5-4c62-bcaa-1b5b5a39ad1a︡
︠5c4d4c6e-c3e7-4bae-bca7-54edd2f673c4i︠
%md

## Debugging

Let's fix this so that it does check primality.
First, we only need to check if numbers smaller
than the input divide the input.

Second, we need to check for more numbrs than just $2$!

︡6c31a355-49cd-4f27-923f-07b3aa6036f9︡︡{"done":true,"md":"\n## Debugging\n\nLet's fix this so that it does check primality.\nFirst, we only need to check if numbers smaller\nthan the input divide the input.\n\nSecond, we need to check for more numbrs than just $2$!"}
︠40708740-4dd2-4e21-9425-bd5a77a4f961︠

def is_it_prime(p):
    primality = True
    for n in srange(2,p):
        if n.divides(p):
            primality = False
    return primality

︡64a30724-fac5-4f28-a781-a3874a77b06c︡
︠d14f1234-a585-4445-ba02-e8ee3b9d052bi︠
%md

## Did it work?

Now we are checking if $n$ divides $p$ for all whole numbers
$n$ starting with $2$ and going up to $p-1$.
We should still do more testing.
Go ahead, try this for your favoite numbers!

︡653f06f4-e682-4605-98e5-1d8a0cc33db6︡︡{"done":true,"md":"\n## Did it work?\n\nNow we are checking if $n$ divides $p$ for all whole numbers\n$n$ starting with $2$ and going up to $p-1$.\nWe should still do more testing.\nGo ahead, try this for your favoite numbers!"}
︠e31eff42-1157-4337-8bee-6fc3b6ebe88e︠

# code here

︡229e9331-bda7-457c-96ea-7a629f715584︡
︠478fa05b-dcef-4524-b10a-d5386e4229c9i︠
%md

## Into the wild

One of the most intriguing parts of math is that there are still unsolved problems!
We often write programs to help us gather data to see what
should be true and to help us solve these problems.

One open problem is:

>Are there infinitely many twin primes?

Twin primes are pairs of prime numbers that are only two apart.
For example, $3$ and $5$ are twin primes and $11$ and $13$ are twin primes.

That is, twin primes are defined are pairs of numbers $p$ and $p+2$
where both $p$ and $p+2$ are prime. Can you think of any more?

## Let's think about it

It's pretty easy to think for a minute and find all twin primes less than $30$, or even $50$.
But this isn't enough data to draw any conclusions.
Let's write a function that prints out all pairs of twin primes up to a number $M$.

To test for twin primes, we need to check that both $p$ and $p+2$ are prime.
We can use our `is_it_prime` function to do this!

︡c2ab80b7-a844-4784-945c-8f216f9273b3︡︡{"done":true,"md":"\n## Into the wild\n\nOne of the most intriguing parts of math is that there are still unsolved problems!\nWe often write programs to help us gather data to see what\nshould be true and to help us solve these problems.\n\nOne open problem is:\n\n>Are there infinitely many twin primes?\n\nTwin primes are pairs of prime numbers that are only two apart.\nFor example, $3$ and $5$ are twin primes and $11$ and $13$ are twin primes.\n\nThat is, twin primes are defined are pairs of numbers $p$ and $p+2$\nwhere both $p$ and $p+2$ are prime. Can you think of any more?\n\n## Let's think about it\n\nIt's pretty easy to think for a minute and find all twin primes less than $30$, or even $50$.\nBut this isn't enough data to draw any conclusions.\nLet's write a function that prints out all pairs of twin primes up to a number $M$.\n\nTo test for twin primes, we need to check that both $p$ and $p+2$ are prime.\nWe can use our `is_it_prime` function to do this!"}
︠c540a47a-d408-4132-acfc-f678c48a6711︠

def twin_primes(M):
    for n in srange(2,M+1):
        if is_it_prime(n) and is_it_prime(n+2):
            print(n,n+2)

︡66d0244e-840f-4b3f-b6e1-437aa9d5af6b︡
︠8ec98b75-5199-4695-aee6-b138c5d15ed9i︠
%md

### Challenge

Can you use the above function to find out how many
twin prime pairs there are up to 100? How about 1000?
Do you think there are infinitely many twin primes?

︡7d2346eb-12f6-456e-89b5-8feb7d55bfe5︡︡{"done":true,"md":"\n### Challenge\n\nCan you use the above function to find out how many\ntwin prime pairs there are up to 100? How about 1000?\nDo you think there are infinitely many twin primes?"}
︠1e69a2d9-6c37-401a-81e4-016b1ee27d2a︠

#Try out you're code here

︡8598c48d-8469-4886-a156-065f44f9d041︡
︠1f1502c5-8279-4456-abac-c92ef9a34bfdi︠
%md

## Another Challenge

Can you write a function that finds all pairs of primes that differ by 4?
These are called *cousin primes*.
Do you think there are infinitely many pairs of cousin primes?

How about pairs of primes that differ by $3$? How many such pairs can you find?
Can you think as to why the data for primes that differ by $3$ looks so
different than that for primes that differ by $2$ or $4$?

︡2287656b-7139-4201-98d8-af74a3592688︡︡{"done":true,"md":"\n## Another Challenge\n\nCan you write a function that finds all pairs of primes that differ by 4?\nThese are called *cousin primes*.\nDo you think there are infinitely many pairs of cousin primes?\n\nHow about pairs of primes that differ by $3$? How many such pairs can you find?\nCan you think as to why the data for primes that differ by $3$ looks so\ndifferent than that for primes that differ by $2$ or $4$?"}
︠01240521-e6dd-4e50-b4b2-f32653706d4f︠










